Codeforces Round #447 (Div. 2) D. Ralph And His Tour in Binary Country [思维+空间优化]

D. Ralph And His Tour in Binary Country
time limit per test
2.5 seconds
memory limit per test
512 megabytes
input
standard input
output
standard output

Ralph is in the Binary Country. The Binary Country consists of n cities and (n - 1) bidirectional roads connecting the cities. The roads are numbered from 1 to (n - 1), the i-th road connects the city labeled  (here ⌊ x denotes the x rounded down to the nearest integer) and the city labeled (i + 1), and the length of the i-th road is Li.

Now Ralph gives you m queries. In each query he tells you some city Ai and an integer Hi. He wants to make some tours starting from this city. He can choose any city in the Binary Country (including Ai) as the terminal city for a tour. He gains happiness (Hi - L) during a tour, where L is the distance between the city Ai and the terminal city.

Ralph is interested in tours from Ai in which he can gain positive happiness. For each query, compute the sum of happiness gains for all such tours.

Ralph will never take the same tour twice or more (in one query), he will never pass the same city twice or more in one tour.

Input

The first line contains two integers n and m (1 ≤ n ≤ 1061 ≤ m ≤ 105).

(n - 1) lines follow, each line contains one integer Li (1 ≤ Li ≤ 105), which denotes the length of the i-th road.

m lines follow, each line contains two integers Ai and Hi (1 ≤ Ai ≤ n0 ≤ Hi ≤ 107).

Output

Print m lines, on the i-th line print one integer — the answer for the i-th query.

Examples
input
Copy
2 2
5
1 8
2 4
output
Copy
11
4
input
Copy
6 4
2
1
1
3
2
2 4
1 3
3 2
1 7
output
Copy
11
6
3
28
Note

Here is the explanation for the second sample.

Ralph's first query is to start tours from city 2 and Hi equals to 4. Here are the options:

  • He can choose city 5 as his terminal city. Since the distance between city 5 and city 2 is 3, he can gain happiness 4 - 3 = 1.
  • He can choose city 4 as his terminal city and gain happiness 3.
  • He can choose city 1 as his terminal city and gain happiness 2.
  • He can choose city 3 as his terminal city and gain happiness 1.
  • Note that Ralph can choose city 2 as his terminal city and gain happiness 4.
  • Ralph won't choose city 6 as his terminal city because the distance between city 6 and city 2 is 5, which leads to negative happiness for Ralph.

So the answer for the first query is 1 + 3 + 2 + 1 + 4 = 11.



题意:一颗满二叉树n(1e6)个顶点,边权都知道,一共q(1e5)次询问.从ST点出发有生命值H,求dis(st,任意一点x)<=H 的 sgima(H-dis)

思路:

1.对于一个点,出发有三种情况,左儿子/右儿子/父亲,求是否能走到 以及 走到后有多少个可能的值(二分)

2.那么从ST出发一步一步往上走,就相当于是从ST出发 

画图理解一下吧!

时间复杂度:[n(1+1/2+1/4+...)=O(n) ]+ O(nlogn  *  log(logn))+O(q*logn*log(logn))

这道题还要注意空间复杂度: nlogn n=1e6. 正常开会爆内存,开vector优化空间

#include<bits/stdc++.h>
#define PI acos(-1.0)
using namespace std;
typedef long long ll;

const int N=1e6+6;
const int MOD=1e9+7;
const int INF=0x3f3f3f3f;

vector <int> ans[N];
vector <ll> sum[N];
int cost[N],h;
int n,q,st,last;

/// distance bewteen subtree root and subtree node
void dfs(int now,int rt,int fdis){
    if(now>n)   return ;
    int lson=now*2,rson=now*2+1;
    if(lson<=n) ans[rt].push_back(cost[lson]+fdis),dfs(lson,rt,cost[lson]+fdis);
    if(rson<=n) ans[rt].push_back(cost[rson]+fdis),dfs(rson,rt,cost[rson]+fdis);
}


int main(void){
    cin >> n>>q;
    for(int i=2;i<=n;i++)   scanf("%d",&cost[i]);
    for(int i=1;i<=n;i++)
        ans[i].push_back(0),dfs(i,i,0);

    for(int i=1;i<=n;i++){
        sort(ans[i].begin(),ans[i].end());
        sum[i].resize((int)ans[i].size()+1,0);
        for(int j=1;j<(int)ans[i].size();++j){
            sum[i][j]+=sum[i][j-1]+1ll*ans[i][j];
        }
    }

//    for(int i=1;i<=n;i++){
//        printf("%d: ",i);
//        for(auto j : ans[i])    printf("%lld ",j);
//        cout<<endl;
//        for(auto j : sum[i])    printf("%lld ",j.second);puts("*************");
//    }


    for(int i=1;i<=q;i++){
        scanf("%d%d",&st,&h);
        ll res=0;
        while(st>0 && h>0){
            res+=1ll*h;
            int lson=st*2;
            int rson=st*2+1;
            if(last!=lson && lson<=n){
                int te=h-cost[lson];
//                cout <<"te="<<te<<endl;
                if(te>0){
                    res+=te;
//                    cout <<"te1="<<te<<endl;
                    int pos=prev(lower_bound(ans[lson].begin(),ans[lson].end(),te))-ans[lson].begin();
//                    cout <<"pos="<<pos<<endl;
                    res+= (1ll*pos*te-sum[lson][pos]);
                }
//                cout <<"rse1="<<res<<endl;
            }
            if(last!=rson && rson<=n){
                int te=h-cost[rson];
                if(te>0){
                    res+=te;
                    int pos=prev(lower_bound(ans[rson].begin(),ans[rson].end(),te))-ans[rson].begin();
                    res+= (1ll*pos*te-sum[rson][pos]);
                }
//                cout <<"rse2="<<res<<endl;
            }
            last=st;
            h-=cost[last];
//            cout <<"h="<<h<<endl;
            st/=2;
//            cout <<"st="<<st<<endl;
        }
            cout << res  << endl;
    }


    return 0;
}
/*********
6 4
2
1
1
3
2
1 3

*********/


猜你喜欢

转载自blog.csdn.net/haipai1998/article/details/79930596